// Generated by IcedCoffeeScript 108.0.11
var RiemannQuery, antlr_ast, antlr_parser, ast, ast_predicate, ast_prefix, ast_regex, cache, clj_ast, clj_ast_field, clj_ast_guarded_prefix, clj_ast_regex_match, clj_ast_tagged, cons, count, escapeRegExp, first, fun, fun_cache_add, fun_cache_lookup, identity, isNumber, isString, isType, join, js_ast, keys, keyword, keywords, last, list, make_regex, re_pattern, re_seq, remove, second, sequential, unquote,
  __slice = [].slice,
  __indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; };

first = function(arr) {
  return arr[0];
};

second = function(arr) {
  return arr[1];
};

last = function(arr) {
  return arr.slice(-1);
};

count = function(arr) {
  return arr.length;
};

sequential = function(arr) {
  return Array.isArray(arr);
};

remove = function(pred, arr) {
  var item, _i, _len, _results;
  _results = [];
  for (_i = 0, _len = arr.length; _i < _len; _i++) {
    item = arr[_i];
    if (!pred(item)) {
      _results.push(item);
    }
  }
  return _results;
};

isType = function(type) {
  return function(item) {
    return typeof item === type;
  };
};

isString = isType("string");

isNumber = isType("number");

re_pattern = function(str) {
  return (new RegExp(str, "g")).toString();
};

re_seq = function(regexp, str) {
  return str.match(regexp);
};

unquote = function(str) {
  return (isString(str)) && ((first(str)) === '"' && (last(str)) === '"') && str.slice(1, -1) || str;
};

identity = function(obj) {
  return obj;
};

list = function() {
  var items;
  items = 1 <= arguments.length ? __slice.call(arguments, 0) : [];
  return items;
};

cons = function(x, arr) {
  return (function(func, args, ctor) {
    ctor.prototype = func.prototype;
    var child = new ctor, result = func.apply(child, args);
    return Object(result) === result ? result : child;
  })(Array, [x].concat(__slice.call(arr)), function(){});
};

join = function(sep, arr) {
  if (arr) {
    return arr.join(sep);
  } else {
    return sep.join("");
  }
};

keywords = ["state", "host", "service", "description", "metric_f", "metric", "time", "ttl", "meta"];

keyword = function(word) {
  return __indexOf.call(keywords, word) >= 0;
};

RiemannQuery = (function() {
  function RiemannQuery() {}

  return RiemannQuery;

})();


/*
  "The query parser. Parses strings into ASTs, and converts ASTs to functions
  which match events."
 */

escapeRegExp = require("lodash.escaperegexp");

antlr_parser = require("./parser");

ast_predicate = function(terms) {
  var t1, t2, _;
  switch (false) {
    case (count(terms)) !== 1:
      return antlr_ast(first(terms));
    case !((first(terms)) === "not" && (count(terms)) === 2):
      return list("!", antlr_ast(second(terms)));
    case !((second(terms)) === "or" && (count(terms)) === 3):
      t1 = terms[0], _ = terms[1], t2 = terms[2];
      return list("||", antlr_ast(t1), antlr_ast(t2));
    case !((second(terms)) === "and" && (count(terms)) === 3):
      t1 = terms[0], _ = terms[1], t2 = terms[2];
      return list("&&", antlr_ast(t1), antlr_ast(t2));
    default:
      throw new Error("Unexpected predicate structure: " + terms);
  }
};

ast_prefix = function(sym, terms) {

  /*
  "Rewrites binary expressions from infix to prefix. Takes a symbol `(e.g. '=)`
  and a 3-element seq like `(1 \"=\" 2)` and emits `(= 1 2)`, ignoring the
  middle term and transforming t1 and t2."
   */
  var t1, t2, _;
  t1 = terms[0], _ = terms[1], t2 = terms[2];
  return list(sym, antlr_ast(t1), antlr_ast(t2));
};

ast_regex = function(type, terms) {

  /*
  "Takes a type of match (:like or :regex), a list of three string terms: an
  AST resolving to a string, the literal =~ (ignored), and a pattern. Returns
  `(:regex pattern string-ast)`.
  
  For :regex matches, emits a regular expression pattern.
  For :like matches, emits a string pattern."
   */
  var pattern, string, _;
  string = terms[0], _ = terms[1], pattern = terms[2];
  return [
    type, (function() {
      switch (type) {
        case "regex":
          return re_pattern(unquote(antlr_ast(pattern)));
        case "like":
          return antlr_ast(pattern);
      }
    })(), antlr_ast(string)
  ];
};

antlr_ast = function(tree) {

  /*
  "Converts a parse tree to an intermediate AST which is a little easier to
  analyze and work with. This is the AST we use for optimization and which is
  passed to various query compilers. Turns literals into their equivalent JVM
  types, and eliminates some unnecessary parser structure."
   */
  var node_type, terms;
  node_type = tree[0], terms = 2 <= tree.length ? __slice.call(tree, 1) : [];
  switch (node_type) {
    case "primary":
      return antlr_ast(first(remove(isString, terms)));
    case "simple":
      return antlr_ast(first(terms));
    case "value":
      return antlr_ast(first(terms));
    case "number":
      return antlr_ast(first(terms));
    case "predicate":
      return ast_predicate(terms);
    case "equal":
      return ast_prefix('==', terms);
    case "not_equal":
      return ast_prefix('!=', terms);
    case "lesser":
      return ast_prefix('<', terms);
    case "greater":
      return ast_prefix('>', terms);
    case "lesser_equal":
      return ast_prefix('<=', terms);
    case "greater_equal":
      return ast_prefix('>=', terms);
    case "regex_match":
      return ast_regex("regex", terms);
    case "like":
      return ast_regex("like", terms);
    case "tagged":
      return list("tagged", antlr_ast(second(terms)));
    case "r_long":
      return parseInt(first(terms));
    case "r_float":
      return parseFloat(first(terms));
    case "bign":
      return parseInt(first(terms));
    case "string":
      return String(first(terms));
    case "field":
      return String(first(terms));
    case "r_true":
      return true;
    case "r_false":
      return false;
    case "nil":
      return null;
    default:
      return cons(node_type, terms.map(function(term) {
        if (sequential(term)) {
          return antlr_ast(term);
        } else {
          return term;
        }
      }));
  }
};

ast = function(str) {
  return antlr_ast(antlr_parser(str));
};

clj_ast_guarded_prefix = function(f, check, a_b) {
  var a, b;
  a = a_b[0], b = a_b[1];

  /*
  (list 'let ['a (clj_ast a)
              'b (clj_ast b)]
        (list 'and
              (list check 'a)
              (list check 'b)
              (list f 'a 'b))))
   */
  return list(f, clj_ast(a), clj_ast(b));
};

clj_ast_field = function(field) {

  /*
  "Takes a keyword field name and emits an expression to extract that field
  from an 'event map, e.g. `(:fieldname event)`."
   */
  return "event[\"" + field + "\"]";
};

clj_ast_tagged = function(tag) {
  return "(event.tags.indexOf(" + tag + ") !== -1)";
};

make_regex = function(str) {
  var pairs, tokens;
  tokens = re_seq(/%|[^%]+/g, str.slice(1, -1));
  pairs = tokens.map(function(token) {
    switch (token) {
      case "%":
        return ".*";
      default:
        return escapeRegExp(token);
    }
  });
  return re_pattern("^" + (join(pairs)) + "$");
};

clj_ast_regex_match = function(pattern_transformer, pattern_field) {

  /*
  "Takes a pattern transformer, and a list of [pattern string-ast], and emits
  code to match the string-ast's results with a regex match, compiling pattern
  with pattern-transformer."
   */
  var field, pattern, regexp, str;
  pattern = pattern_field[0], field = pattern_field[1];
  str = clj_ast(field);
  regexp = pattern_transformer(pattern);
  return "!!" + regexp + ".exec(" + str + ")";
};

clj_ast = function(ast) {
  var node_type, terms;
  switch (false) {
    case !(keyword(ast)):
      return clj_ast_field(ast);
    case !!(sequential(ast)):
      return ast;
    default:
      node_type = ast[0], terms = 2 <= ast.length ? __slice.call(ast, 1) : [];
      switch (node_type) {
        case "==":
          return list.apply(null, ['=='].concat(__slice.call(terms.map(clj_ast))));
        case "<":
          return clj_ast_guarded_prefix("<", isNumber, terms);
        case ">":
          return clj_ast_guarded_prefix(">", isNumber, terms);
        case "<=":
          return clj_ast_guarded_prefix("<=", isNumber, terms);
        case ">=":
          return clj_ast_guarded_prefix(">=", isNumber, terms);
        case "like":
          return clj_ast_regex_match(make_regex, terms);
        case "regex":
          return clj_ast_regex_match(identity, terms);
        case "tagged":
          return clj_ast_tagged(first(terms));
        default:
          return cons(node_type, terms.map(clj_ast));
      }
  }
};

js_ast = function(ast) {
  var node_type, terms;
  switch (false) {
    case !!(sequential(ast)):
      return ast;
    default:
      node_type = ast[0], terms = 2 <= ast.length ? __slice.call(ast, 1) : [];
      switch (node_type) {
        case "!":
          terms = list(null, first(terms));
      }
      return join(" ", list("(", js_ast(first(terms)), node_type, js_ast(second(terms)), ")"));
  }
};

cache = {};

keys = [];


/*
"Speeds up the compilation of queries by caching map of ASTs to corresponding
functions."
 */

fun_cache_add = function(key, item) {
  var old;
  keys.push(key);
  cache[key] = item;
  if (keys.length > 64) {
    old = keys.shift();
    return delete cache[old];
  }
};

fun_cache_lookup = function(key) {
  return cache[key];
};

fun = function(ast) {

  /*
  "Transforms an AST into a fn [event] which returns true if the query matches
  that event. Example:
  
  (def q (fun (ast \"metric > 2\")))
  (q {:metric 1}) => false
  (q {:metric 3}) => true"
   */
  var fn;
  if (fn = fun_cache_lookup(ast)) {
    return fn;
  } else {
    fn = Function("event", "return " + (js_ast(clj_ast(ast))));
    fun_cache_add(ast, fn);
    return fn;
  }
};

RiemannQuery.ast = ast;

RiemannQuery.antlr_ast = antlr_ast;

RiemannQuery.clj_ast = clj_ast;

RiemannQuery.js_ast = js_ast;

RiemannQuery.fun = fun;

module.exports = RiemannQuery;

//# sourceMappingURL=riemann-query.js.map
